#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <pthread.h>
#include <time.h>

#define checkError(expr,userMsg)\
    do {\
        if (!(expr)) {\
            perror(userMsg);\
            exit(EXIT_FAILURE);\
        }\
    } while(0)
#define checkErrorPthread(err,userMsg) \
    do {\
        int _err = err;\
        if (_err > 0) { \
            errno = _err;\
            checkError(0,userMsg);\
        } \
    } while(0);

#define MAX_SIZE (1024)

char** dani = {"nedelja","ponedeljak","utorak","sreda",
                "cetvrtak", "petak", "subota"};

int main(int argc, char** argv) {

    checkError(argc == 3, "args");

    time_t vreme1 = (time_t)atoi(argv[1]);
    struct tm* vreme = localtime(&vreme1);
    checkError(vreme != NULL, "...");
    printf("%s ", dani[vreme->tm_wday]);

    int godine = atoi(argv[2]);
    vreme->tm_year += godine;

    time_t novoVreme = mktime(vreme);
    vreme = localtime(&novoVreme);
    checkError(vreme != NULL, "...");
    printf("%s\n", dani[vreme->tm_wday]);

    exit(EXIT_SUCCESS);
}