#define _XOPEN_SOURCE (700)
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <pthread.h>
#include <time.h>
#include <math.h>

#include <sys/wait.h>
#include <string.h>

#define checkError(expr,userMsg)\
    do {\
        if (!(expr)) {\
            perror(userMsg);\
            exit(EXIT_FAILURE);\
        }\
    } while(0)
#define checkErrorPthread(err,userMsg) \
    do {\
        int _err = err;\
        if (_err > 0) { \
            errno = _err;\
            checkError(0,userMsg);\
        } \
    } while(0);

#define RD_END  (0)
#define WR_END  (1)

int main(int argc, char** argv) {

    checkError(argc == 2, "...");
    FILE* f = fopen(argv[1], "r");
    checkError(f != NULL, "...");

    char maksKomanda[256];
    char maksArg[256];
    int maksBroj = -1;

    char* line = NULL;
    ssize_t lineLen = 0;
    while (getline(&line, &lineLen, f) > 0) {
        char komanda[256];
        char argument[256];
        sscanf(line, "%s%s", komanda, argument);

        int cld2par[2];
        checkError(pipe(cld2par) != -1, "...");

        pid_t childPid = fork();
        checkError(childPid != -1, "...");

        if (childPid == 0) {

            close(cld2par[RD_END]);

            checkError(dup2(cld2par[WR_END], STDOUT_FILENO) != -1, "");
            checkError(execlp(komanda, komanda, argument, NULL) != -1, "...");
        }

        int status = 0;
        checkError(wait(&status) != -1, "...");

        close(cld2par[WR_END]);

        if (WIFEXITED(status) && (WEXITSTATUS(status) == EXIT_SUCCESS)) {

            int broj = 0;
            int readBytes = 0;
            char buffer[256];
            while ((readBytes = read(cld2par[RD_END], buffer, 256)) > 0) {
                broj += readBytes;
            }

            checkError(readBytes != -1, "read");
            if (broj  > maksBroj)
            {
                maksBroj = broj;
                strcpy(maksKomanda, komanda);
                strcpy(maksArg, argument);
            }
        }

        close(cld2par[RD_END]);
    }

    printf("%s %s\n", maksKomanda, maksArg);

    free(line);
    fclose(f);

    exit(EXIT_SUCCESS);
}