#define _XOPEN_SOURCE (700)
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <pthread.h>
#include <time.h>
#include <math.h>

#include <sys/wait.h>
#include <string.h>

#define checkError(expr,userMsg)\
    do {\
        if (!(expr)) {\
            perror(userMsg);\
            exit(EXIT_FAILURE);\
        }\
    } while(0)
#define checkErrorPthread(err,userMsg) \
    do {\
        int _err = err;\
        if (_err > 0) { \
            errno = _err;\
            checkError(0,userMsg);\
        } \
    } while(0);

int main(int argc, char** argv) {

    checkError(argc == 3, "...");
    int fd = open(argv[1], O_RDWR);
    checkError(fd != -1, "...");

    FILE* f = fdopen(fd, "r+");
    checkError(f != NULL, "...");

    char buffer[256];
    while (fscanf(f, "%s",buffer) == 1) {

        if (strcmp(buffer, argv[2]) == 0) {

            struct flock lock;
            lock.l_type = F_WRLCK;
            lock.l_whence = SEEK_SET;
            lock.l_start = ftell(f);
            lock.l_len = -strlen(buffer);

            checkError(fcntl(fd, F_GETLK, &lock) != -1, "...");

            switch (lock.l_type) {
                case F_RDLCK:
                    printf("r %d\n", ftell(f) - strlen(buffer));
                    break;
                case F_WRLCK:
                    printf("w %d\n", ftell(f) - strlen(buffer));
                    break;
            }
        }
    }

    fclose(f);

    exit(EXIT_SUCCESS);
}